/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: core_config.h 7319 2013-04-04 08:10:50Z shigihara $
 */

/*
 *		¸⥸塼ARMѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_CORE_CONFIG_H
#define TOPPERS_CORE_CONFIG_H

/*
 *  ARM¸
 */
#include "arm.h"


/*
 *  顼åˡλ
 */
#define CHECK_STKSZ_ALIGN	8   /* åΥ饤ñ */
#define CHECK_FUNC_ALIGN	4   /* ؿΥ饤ñ */
#define CHECK_FUNC_NONNULL      /* ؿNULLå */
#define CHECK_STACK_ALIGN	4   /* åΰΥ饤ñ */
#define CHECK_STACK_NONNULL     /* åΰNULLå */

/*
 *  ߶ػߤȤCPSRΥѥ
 */
#define CPSR_INTLOCK		(CPSR_IRQ_BIT)

/*
 *  CPSR˾˥åȤѥ
 */
#ifndef CPSR_ALWAYS_SET
#define CPSR_ALWAYS_SET	0x00
#endif /* CPSR_ALWAYS_SET */

/*
 *  㳰ֹ
 */
#define EXCH_NO_RESET	0
#define EXCH_NO_UNDEF	1
#define EXCH_NO_SWI		2
#define EXCH_NO_PABORT	3
#define EXCH_NO_DABORT	4
#define EXCH_NO_IRQ		5
#define EXCH_NO_FIQ		6

/*
 *  㳰θĿ
 */
#define TNUM_EXCH			7

#define call_errorhook(ercd, svcid)	stack_change_and_call_func_2((void *) internal_call_errorhook, (ercd), (svcid))
#define call_shutdownhook(ercd)	stack_change_and_call_func_1((void *) internal_call_shtdwnhk, (ercd))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_OSTKPT(stk, stksz)	((StackType *) ((sint8 *) (stk) + (stksz)))

/*
 *  ץåü̿Υ饤ؿ
 */
#include "core_insn.h"

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void			*sp;            /* åݥ */
	FunctionRefType	pc;             /* ץ५ */
} TSKCTXB;


/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  ARM¸ǤϡOS߶ػ߾
 *  Τߤ갷ͥ٥ޥ׵ػߥե饰˴ؤ
 *  ϡƥåȰ¸Ǽ갷
 */

/*
 *  ƥȻȤΤѿ
 */
extern uint32			excpt_nest_count; /* 㳰ʳ/CPU㳰ˤΥͥȲΥ */

/*
 * x_nested_lock_os_int()ΥͥȲ
 * νѲʤ褦volatile ꡥ
 */
extern volatile uint8	nested_lock_os_int_cnt;

extern void x_nested_lock_os_int(void);
extern void x_nested_unlock_os_int(void);
extern void x_lock_all_int(void);
extern void x_unlock_all_int(void);

#define x_suspend_lock_os_int	x_nested_lock_os_int
#define x_resume_unlock_os_int	x_nested_unlock_os_int

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcore_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡOS߶ػ߾֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡcore_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡߶ػ߾֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåcore_support.S
 *
 *  exit_and_dispatchϡTerminateTaskƤӽФ٤Τǡƥ
 *  ȡOS߶ػ߾֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽ
 *  ʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;


/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ
 */
extern void start_r(void);

#define activate_context(p_tcb)											  \
	{																	  \
		(p_tcb)->tskctxb.sp = (void *) ((char8 *) ((p_tcb)->p_tinib->stk) \
										+ (p_tcb)->p_tinib->stksz);		  \
		(p_tcb)->tskctxb.pc = (FunctionRefType) start_r;				  \
	}

/*
 *  ץå¸ν
 */
extern void core_initialize(void);

/*
 *  ץå¸νλ
 */
extern void core_terminate(void);

/*
 *  ٥ơ֥̿ᤫ黲Ȥ른襢ɥ쥹
 * start.S
 */
extern void	*vector_ref_tbl;

/*
 *  㳰ϥɥ
 */

/*
 *  ̤̿ 㳰ϥɥcore_support.S
 */
extern void undef_handler(void);

/*
 *  SWI 㳰ϥɥcore_support.S
 */
extern void swi_handler(void);

/*
 *  ץեåܡ 㳰ϥɥcore_support.S
 */
extern void prefetch_handler(void);

/*
 *  ǡܡ 㳰ϥɥcore_support.S
 */
extern void data_abort_handler(void);

/*
 *  FIQ 㳰ϥɥcore_support.S
 */
extern void fiq_handler(void);

extern void stack_change_and_call_func_1(void *func, uint32 arg1);
extern void stack_change_and_call_func_2(void *func, uint32 arg1, uint32 arg2);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_CONFIG_H */
