/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: core_sil.h 7319 2013-04-04 08:10:50Z shigihara $
 */

/*
 *		sil.hΥ¸ARMѡ
 */

#ifndef TOPPERS_CORE_SIL_H
#define TOPPERS_CORE_SIL_H

#ifndef TOPPERS_MACRO_ONLY

#ifdef __thumb__
/*
 *  쥸ؿ
 */

/*
 *  ơ쥸CPSRˤθͤɽФ
 */
extern uint32 current_sr(void);

/*
 *  ơ쥸CPSRˤθͤѹ
 */
extern void set_sr(uint32 sr);
#endif /* __thumb__ */

/*
 *  ٤ƤγߡFIQIRQˤζػ
 */
LOCAL_INLINE uint32
TOPPERS_disint(void)
{
	uint32	cpsr;
	uint32	irq_fiq_mask;

#ifndef __thumb__
	Asm("mrs  %0,CPSR" : "=r" (cpsr));
	irq_fiq_mask = cpsr & (0x40 | 0x80);
	cpsr |= (0x40 | 0x80);
	Asm("msr CPSR, %0" : : "r" (cpsr) : "memory", "cc");
#else /* __thumb__ */
	cpsr = current_sr();
	irq_fiq_mask = cpsr & (0x40 | 0x80);
	cpsr |= (0x40 | 0x80);
	set_sr(cpsr);
#endif /* __thumb__ */

	return(irq_fiq_mask);
}

/*
 *  FIQ,IRQ
 */
LOCAL_INLINE void
TOPPERS_set_fiq_irq(uint32 TOPPERS_irq_fiq_mask)
{
	uint32 cpsr;

#ifndef __thumb__
	Asm("mrs  %0,CPSR" : "=r" (cpsr));
	cpsr = cpsr & ~(0x40 | 0x80);
	cpsr = cpsr | (TOPPERS_irq_fiq_mask & (0x40 | 0x80));
	Asm("msr CPSR, %0" : : "r" (cpsr) : "memory", "cc");
#else /* __thumb__ */
	cpsr = current_sr();
	cpsr = cpsr &  ~(0x40 | 0x80);
	cpsr = cpsr | (TOPPERS_irq_fiq_mask &  (0x40 | 0x80));
	set_sr(cpsr);
#endif /* __thumb__ */
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC		uint32 TOPPERS_irq_fiq_mask
#define SIL_LOC_INT()	((void) (TOPPERS_irq_fiq_mask = TOPPERS_disint()))
#define SIL_UNL_INT()	(TOPPERS_set_fiq_irq(TOPPERS_irq_fiq_mask))

/*
 *  ֥ؿ
 */

/*
 *  32ӥåñ̤ɽФ
 */

LOCAL_INLINE uint32
sil_rew_mem(uint32 *mem)
{
	uint32 data;

	data = *((volatile uint32 *) mem);
	return(data);
}
LOCAL_INLINE void
sil_wrw_mem(uint32 *mem, uint32 data)
{
	*((volatile uint32 *) mem) = data;
}

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CORE_SIL_H */
