/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: taua_timer.h 7420 2013-04-23 14:08:00Z honda $
 */

/*
 *		ޥɥ饤СTAUA0 Timerѡ
 */

#ifndef TOPPERS_TAUA0_TIMER_H
#define TOPPERS_TAUA0_TIMER_H

#include "prc_sil.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽȥޥñ̤ȤѴ
 *
 */
#define TO_USEC(clock)	((((SystemTimeUsType) (clock)) * 1000U) / TIMER_CLOCK)

/*
 *  ͤɽ100ʥñ̤ȤѴ
 *
 */
#define TO_100NSEC(clock)	((((SystemTimeUsType) (clock)) * 10000U) / TIMER_CLOCK)

/*
 *  ޥñ̤Ǥλ
 */
extern SystemTimeUsType get_tim_utime(void);

/*
 *  100ʥñ̤Ǥλ
 */
extern SystemTime100NsType get_tim_100ntime(void);

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ
 */
extern void target_timer_initialize(void);

/*
 *  ޤ߽
 *
 *  ޤưߤ
 */
extern void target_timer_terminate(void);

/*
 *  ޤθͤɽФ
 */
LOCAL_INLINE TickType
target_timer_get_current(void)
{
	TickType count;

	count = sil_reh_mem((void *) (TAUA0CNT(0)));

	return(TIMER_CLOCK - count);
}

/*
 *  ޳׵Υå
 */
LOCAL_INLINE boolean
target_timer_probe_int(void)
{
	return(x_probe_int(TAUA0_IRQ));
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TAUA0_TIMER_H */
