/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.h 7319 2013-04-04 08:10:50Z shigihara $
 */

/*
 *		åװ¸⥸塼AT91SKYEYEѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥե
 *  kernel_impl.hΥåȰ¸ΰդȤʤ
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åץƥΥϡɥ񸻤
 */
#include "at91skyeye.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ݡȤƤSKYEYΥС
 */
#define SUPPORT_SKYEYE_VER	0x1024
#define SUPPORT_DEVM_VER	0x2020

/*
 *  ٥롼򥫡ͥǻĤ
 */
#define VECTOR_KERNEL

/*
 *  ٥롼ʤΥ٥ɥ쥹Ƭ
 */
#define VECTOR_START	0x00

/*
 *  ǡν򤷤ʤ
 */
#define TOPPERS_OMIT_DATA_INIT

/*
 * Ԥ̿
 */
#define ASM_TARGET_WAIT_INTERRUPT	nop

/*
 *  ֹ˴ؤ
 */
#define TMIN_INTNO	UINT_C(1)
#define TMAX_INTNO	18U
#define TNUM_INT	18U

/*
 * ֹ椫顤IRCΤΥӥåȥѥޥ
 */
#define INTNO_BITPAT(intno)	(1U << intno)


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno)	(TMIN_INTNO <= (intno) && (intno) <= TMAX_INTNO)

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
extern uint32 idf;

/*
 *  ͥ٥ޥ饤֥
 *
 *  AT91SAM7Sϳͥ٥ޥIRCǥϡɥŪ˻Ĥ
 *  եȥ¦ͤɤ߽񤭤Ǥʤᡤ׵ػߥե
 *  ˤͥ٥ޥ¸
 */

/*
 *  ߤγͥ٥ޥ
 */
extern PriorityType	ipm;

/*
 *  ͥ٥ޥ˥åȤ롤׵ػߥե饰
 *  Υơ֥
 */
extern const uint32	ipm_mask_tbl[];

/*
 *  OS߶ػ߻γ׵ػߥե饰
 *  Os_Lcfg.cŪ
 */
extern const uint32	os_int_lock_mask;


#endif /* TOPPERS_MACRO_ONLY */

/*
 *  IPMimp_mask_tblΥǥåѴޥ
 */
#define INDEX_IPM(ipm)	(-(ipm))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (ǥ)ͥ٥ޥ
 *
 *  OS߶ػ߾֤ǸƤФ졤ͥ٤OS߶ػ߰ʲͥ٤
 *  뤿ᡤϡɥγߥޥѹɬפϤʤ
 *  ͥ٤ѿipm¸
 */
LOCAL_INLINE void
x_set_ipm(PriorityType intpri)
{
	ipm = intpri;
}

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  ipm֤ͤ
 */
LOCAL_INLINE PriorityType
x_get_ipm(void)
{
	return(ipm);
}

/*
 *  ׵Υå
 */
LOCAL_INLINE boolean
x_probe_int(InterruptNumberType intno)
{
	return(at91skyeye_probe_int(INTNO_BITPAT(intno)));
}

/*
 *  ׵饤°
 *
 */
extern void	x_config_int(InterruptNumberType intno,
						 AttributeType intatr, PriorityType intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
LOCAL_INLINE void
i_begin_int(InterruptNumberType intno)
{

}

/*
 *  ߥϥɥνиɬפIRC
 *
 *  AT91SAM7SǤϡɬפʽϤʤ
 */
LOCAL_INLINE void
i_end_int(InterruptNumberType intno)
{

}

/*
 *  åȥƥ¸ν
 */
extern void target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void target_exit(void) NoReturn;

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);

#ifdef TOPPERS_ENABLE_GCOV_PART
/*
 *  GCOVѥ饤֥
 */
/*
 *  GCOVؿ
 */
extern void gcov_init(void);

/*
 *  GCOVǴؿ
 */
extern void gcov_pause(void);

/*
 * GCOVƳؿ
 */
extern void gcov_resume(void);

/*
 *  GCOVϴؿ
 */
extern void gcov_dump(void);
#endif /* TOPPERS_ENABLE_GCOV_PART */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARMѡ
 */
#include "arm_gcc/common/core_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */
