/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_test.c 7252 2013-03-27 10:49:44Z fsi-dankei $
 */

/*
 *		ʲϡɥ󥿥ץΥåȰ¸V850ѡ
 *
 *  Ѥ륿ޡ
 *    ʬޡŪλ֤ꤹθ߻(ͥ)
 *              ȼλ֤Ȥл֤򥫥Ȥ뤳Ȥ
 *              Ūл֤λȤȤ
 *              count mode:count down once
 *
 *    ͥޡ󥿼ʬΥ١ޤ¸
 *              (л֤򥫥)
 *              count mode:continuous count down
 *
 *    ޤ嵭Υޤ32bitΥ󥫥󥿥ޤǤ
 *
 *  ˡ
 *
 *   ͥޤϥ桼󥿺2+1ޤǥȤ
 *   ޤȤϢ³ȥ󤷤ơ˸߻
 *   롥ȯɬפʤᡤߤʤ⡼
 *
 *   ʬޤϡλԤᡤߤ⡼ɤư
 *   顼ʤɤλȥޡ1Ǽ߻κ
 *   ͥޤꤹ
 *
 *  ݥȡ
 *   λϡ߻ƶʤᡤͥޤߤƤ
 *
 */

#include "Os.h"

#include "v850e2m_gcc/prc_sil.h"
#include "target_test.h"
#include "sysmod/syslog.h"

/* ؿΥץȥ */
static TickType get_curr_time(uint32 irq_no, TickType maxval);
static void init_hwcounter(uint32 irq_no, TickType maxval, TimeType nspertick, TickRefType cycle);
static void start_hwcounter(uint32 irq_no);
static void stop_hwcounter(uint32 irq_no);
static void set_hwcounter(uint32 irq_no, TickType exprtick, TickType maxval);
static TickType get_hwcounter(uint32 irq_no, TickType maxval);
static void cancel_hwcounter(uint32 irq_no);
static void trigger_hwcounter(uint32 irq_no);
static void int_clear_hwcounter(uint32 irq_no);
static void int_cancel_hwcounter(uint32 irq_no);
static void increment_hwcounter(uint32 irq_no);

/*
 *  ׵ֹH/WͥѴ
 *  ̵ʥͥ0xffff֤
 */

static uint16
irq_no2taua_ch(uint32 irq_no)
{

	uint16 ch;

	switch (irq_no) {

	case TAUA_CH0:
		ch = 0x0001;
		break;
	case TAUA_CH1:
		ch = 0x0002;
		break;
	case TAUA_CH2:
		ch = 0x0004;
		break;
	case TAUA_CH3:
		ch = 0x0008;
		break;
	case TAUA_CH4:
		ch = 0x0010;
		break;
	case TAUA_CH5:
		ch = 0x0020;
		break;
	case TAUA_CH6:
		ch = 0x0040;
		break;
	case TAUA_CH7:
		ch = 0x0080;
		break;
	case TAUA_CH8:
		ch = 0x0100;
		break;
	case TAUA_CH9:
		ch = 0x0200;
		break;
	case TAUA_CH10:
		ch = 0x0400;
		break;
	case TAUA_CH11:
		ch = 0x0800;
		break;
	case TAUA_CH12:
		ch = 0x1000;
		break;
	case TAUA_CH13:
		ch = 0x2000;
		break;
	case TAUA_CH14:
		ch = 0x4000;
		break;
	case TAUA_CH15:
		ch = 0x8000;
		break;
	default:
		ch = 0xffff;
		break;
	}
	return(ch);

}
/*
 *  TAUAn ޤưϡ߽
 */
static void
set_timer_start_stop(uint32 irq_no, boolean start)
{
	uint16 ch;

	ch = irq_no2taua_ch(irq_no);

	if (start == 1)	{
		/* ޳Ͻ */
		sil_wrh_mem((void *) TAUA0TS, ch);                          // ư
	}
	else {
		/* ߽ */
		sil_wrh_mem((void *) TAUA0TT, ch);                          // ư
	}
}
/*
 *  TAUAn ׵Υꥢ
 */
static void
clear_EIRFn(uint32 irq_no)
{
	uint16 wk;

	wk = sil_reh_mem((void *) ICTAUA0I(irq_no));
	wk &= ~EIRFn;                                           // ׵᥯ꥢ
	sil_wrh_mem((void *) ICTAUA0I(irq_no), wk);

}
/*
 *  TAUAn ߶ػߡ
 */
static void
set_EIMKn(uint32 irq_no, boolean set)
{
	uint16 wk;

	wk = sil_reh_mem((void *) ICTAUA0I(irq_no));
	if (set == 0) {
		wk |= EIMKn;                                                    // ߶ػ
	}
	else {
		wk &= ~EIMKn;                                                   // ߵ
	}
	sil_wrh_mem((void *) ICTAUA0I(irq_no), wk);
}

/*
 *  ϡɥ󥿸ߥƥåͼ
 */
static TickType
get_curr_time(uint32 irq_no, TickType maxval)
{
	TickType	count;

	TickType	curr_time = 0U;

	count = sil_reh_mem((void *) (TAUA0CNT(irq_no + 1)));

	/* 󥫥󥿤ΰ١ߥåͤѴ */
	curr_time = maxval - count;

	return(curr_time);
}

/*
 *  ϡɥ󥿤ν
 */
static void
init_hwcounter(uint32 irq_no, TickType maxval, TimeType nspertick, TickRefType cycle)
{

	*cycle = maxval;

	/* ʬ߽ */
	set_timer_start_stop(irq_no, 0);
	set_EIMKn(irq_no, 0);                                           /* ߶ػ */
	clear_EIRFn(irq_no);                                            /* ׵᥯ꥢ */

	/* ʬޤ򥤥󥿡Х륿ޤȤ */
	sil_wrh_mem((void *) TAUA0CMOR(irq_no), MCU_TAUA00_CMOR);       // 󥿡Х륿ޤȤƻ
	sil_wrb_mem((void *) TAUA0CMUR(irq_no), MCU_TAUA00_CMUR);

	/* ߽ͥ */
	set_timer_start_stop(irq_no + 1, 0);
	set_EIMKn(irq_no + 1, 0);                                           /* ߶ػ */
	clear_EIRFn(irq_no + 1);                                            /* ׵᥯ꥢ */

	/* ͥޤ򥤥󥿡Х륿ޤȤ */
	sil_wrh_mem((void *) TAUA0CMOR(irq_no + 1), MCU_TAUA00_CMOR);     // 󥿡Х륿ޤȤƻ
	sil_wrb_mem((void *) TAUA0CMUR(irq_no + 1), MCU_TAUA00_CMUR);

	sil_wrh_mem((void *) TAUA0CDR(irq_no + 1), maxval);              // ޥȼ

}
/*
 *  ϡɥ󥿤γ
 */
static void
start_hwcounter(uint32 irq_no)
{

	/* ͥ޳ */
	set_timer_start_stop(irq_no + 1, 1);

}

/*
 *  ϡɥ󥿤
 */
static void
stop_hwcounter(uint32 irq_no)
{

	/* ʬޤ */
	set_timer_start_stop(irq_no, 0);

	/* ʬޤγ׵Υꥢ */
	set_EIMKn(irq_no, 0);                                           /* ߶ػ */
	clear_EIRFn(irq_no);                                            /* ׵᥯ꥢ */

	/* ͥޤ */
	set_timer_start_stop(irq_no + 1, 0);

	/* ͥޤγ׵Υꥢ */
	set_EIMKn(irq_no + 1, 0);                                           /* ߶ػ */
	clear_EIRFn(irq_no + 1);                                            /* ׵᥯ꥢ */
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
static void
set_hwcounter(uint32 irq_no, TickType exprtick, TickType maxval)
{
	TickType	curr_time;
	TickType	value;

	/* ʬޤγ׵Υꥢ */
	clear_EIRFn(irq_no);                                            /* ׵᥯ꥢ */

	/* ߻μ	*/
	curr_time = get_curr_time(irq_no, maxval);

	/* ޤꤹͤ򻻽	*/
	if (exprtick >= curr_time) {
		value = exprtick - curr_time;
	}
	else {
		value = (exprtick - curr_time) + (maxval + 1U);
	}

	/*
	 *  ޤ0x00ꤷȯ塤0ꤷ硤2ܤ
	 *  0x00γߤȯʤΤǡ0x00ͤ0x01ľ
	 */
	if (value == 0x00U) {
		value = 0x01U;
	}

	/* ʬޤΥ */
	sil_wrh_mem((void *) TAUA0CDR(irq_no), (value));

	/*
	 * ȳ
	 */
	set_timer_start_stop(irq_no, 1);

}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
static TickType
get_hwcounter(uint32 irq_no, TickType maxval)
{
	return(get_curr_time(irq_no, maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
static void
cancel_hwcounter(uint32 irq_no)
{
	set_timer_start_stop(irq_no, 0);
}
/*
 *  ϡɥ󥿤ζ׵
 */
static void
trigger_hwcounter(uint32 irq_no)
{
	/* ʬ */
	set_timer_start_stop(irq_no, 0);                                /* ޤ */

	/* ʬޤγ׵Υꥢ */
	clear_EIRFn(irq_no);                                            /* ׵᥯ꥢ */
	set_EIMKn(irq_no, 1);                                           /* ߵ */

	/* ʬޥ󥿡0x01򥻥åȤ뤳Ȥǡλ */
	sil_wrh_mem((void *) TAUA0CDR(irq_no), (1));


	/*  ʬ޳ */
	set_timer_start_stop(irq_no, 1);

}

/*
 *  ׵Υꥢ
 */
static void
int_clear_hwcounter(uint32 irq_no)
{

	clear_EIRFn(irq_no);                                            /* ׵᥯ꥢ */

}

/*
 *  ׵Υ󥻥
 *  ڥǥ󥰤Ƥ׵򥭥󥻥
 */
static void
int_cancel_hwcounter(uint32 irq_no)
{

	clear_EIRFn(irq_no);                                            /* ׵᥯ꥢ */

}

/*
 *  ϡɥ󥿤Υ󥯥
 */
static void
increment_hwcounter(uint32 irq_no)
{
	/* ̤ݡ */
	return;
}

/*
 *  A
 */
/* 󥿤κͤ2+1 */
static TickType SmpHwCntA_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_SmpHwCntA(TickType maxval, TimeType nspertick)
{
	init_hwcounter(TAUA_CH1, maxval, nspertick, &SmpHwCntA_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_SmpHwCntA(void)
{
	start_hwcounter(TAUA_CH1);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_SmpHwCntA(void)
{
	stop_hwcounter(TAUA_CH1);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_SmpHwCntA(TickType exprtick)
{
	set_hwcounter(TAUA_CH1, exprtick, SmpHwCntA_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_SmpHwCntA(void)
{
	return(get_hwcounter(TAUA_CH1, SmpHwCntA_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_SmpHwCntA(void)
{
	cancel_hwcounter(TAUA_CH1);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_SmpHwCntA(void)
{
	trigger_hwcounter(TAUA_CH1);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_SmpHwCntA(void)
{
	int_clear_hwcounter(TAUA_CH1);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_SmpHwCntA(void)
{
	int_cancel_hwcounter(TAUA_CH1);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_SmpHwCntA(void)
{
	increment_hwcounter(TAUA_CH1);
}

/*
 *  B
 */
/* 󥿤κͤ2+1 */
static TickType SmpHwCntB_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_SmpHwCntB(TickType maxval, TimeType nspertick)
{
	init_hwcounter(TAUA_CH3, maxval, nspertick, &SmpHwCntB_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_SmpHwCntB(void)
{
	start_hwcounter(TAUA_CH3);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_SmpHwCntB(void)
{
	stop_hwcounter(TAUA_CH3);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_SmpHwCntB(TickType exprtick)
{
	set_hwcounter(TAUA_CH3, exprtick, SmpHwCntB_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_SmpHwCntB(void)
{
	return(get_hwcounter(TAUA_CH3, SmpHwCntB_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_SmpHwCntB(void)
{
	cancel_hwcounter(TAUA_CH3);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_SmpHwCntB(void)
{
	trigger_hwcounter(TAUA_CH3);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_SmpHwCntB(void)
{
	int_clear_hwcounter(TAUA_CH3);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_SmpHwCntB(void)
{
	int_cancel_hwcounter(TAUA_CH3);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_SmpHwCntB(void)
{
	increment_hwcounter(TAUA_CH3);
}

/*
 *  C
 */
/* 󥿤κͤ2+1 */
static TickType SmpHwCntC_maxval;

/*
 *  ϡɥ󥿤ν
 */
void
init_hwcounter_SmpHwCntC(TickType maxval, TimeType nspertick)
{
	init_hwcounter(TAUA_CH5, maxval, nspertick, &SmpHwCntC_maxval);
}

/*
 *  ϡɥ󥿤γ
 */
void
start_hwcounter_SmpHwCntC(void)
{
	start_hwcounter(TAUA_CH5);
}

/*
 *  ϡɥ󥿤
 */
void
stop_hwcounter_SmpHwCntC(void)
{
	stop_hwcounter(TAUA_CH5);
}

/*
 *  ϡɥ󥿤ؤλ֤
 */
void
set_hwcounter_SmpHwCntC(TickType exprtick)
{
	set_hwcounter(TAUA_CH5, exprtick, SmpHwCntC_maxval);
}

/*
 *  ϡɥ󥿤θ߻֤μ
 */
TickType
get_hwcounter_SmpHwCntC(void)
{
	return(get_hwcounter(TAUA_CH5, SmpHwCntC_maxval));
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
cancel_hwcounter_SmpHwCntC(void)
{
	cancel_hwcounter(TAUA_CH5);
}

/*
 *  ϡɥ󥿤ζ׵
 */
void
trigger_hwcounter_SmpHwCntC(void)
{
	trigger_hwcounter(TAUA_CH5);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_clear_hwcounter_SmpHwCntC(void)
{
	int_clear_hwcounter(TAUA_CH5);
}

/*
 *  ϡɥ󥿤ꤵ줿λ֤μ
 */
void
int_cancel_hwcounter_SmpHwCntC(void)
{
	int_cancel_hwcounter(TAUA_CH5);
}

/*
 *  ϡɥ󥿤Υ󥯥
 */
void
increment_hwcounter_SmpHwCntC(void)
{
	increment_hwcounter(TAUA_CH5);
}

/*
 *  C1ISRΤΥ޳ȯ
 */
void
trigger_SmpC1ISR_start(void)
{
	/* ʬޤγ׵Υꥢ */
	clear_EIRFn(TAUA_CH7);                                          /* ׵᥯ꥢ */
	set_EIMKn(TAUA_CH7, 1);                                         /* ߵ */
	set_timer_start_stop(TAUA_CH7, 1);                              /* ȥ */
}
/*
 *  C1ISRΤΥ޽
 */
void
trigger_SmpC1ISR_initialize(void)
{
	/* ߽ͥ */
	set_timer_start_stop(TAUA_CH7, 0);
	set_EIMKn(TAUA_CH7, 0);                                         /* ߶ػ */
	clear_EIRFn(TAUA_CH7);                                          /* ׵᥯ꥢ */

	/* ͥޤ򥤥󥿡Х륿ޤȤ */
	sil_wrh_mem((void *) TAUA0CMOR(TAUA_CH7), MCU_TAUA00_CMOR);     // 󥿡Х륿ޤȤƻ
	sil_wrb_mem((void *) TAUA0CMUR(TAUA_CH7), MCU_TAUA00_CMUR);

//*	sil_wrh_mem((void *) TAUA0CDR(TAUA_CH7), TAUAn_10ms );			// ޥȼ
	sil_wrh_mem((void *) TAUA0CDR(TAUA_CH7), TAUAn_700us);          // ޥȼ

}
/*
 *  C1ISRΥץ뤫ƤӽФCؿ
 */
void
c1isr_syslog(void)
{
	syslog(LOG_INFO, "TAUA7_IRQ");
}
